module Map3 where

import List(find, (\\))

data Map alpha beta = Map [(alpha, beta)]    

empty :: Map alpha beta
empty = Map []    

lookup :: Eq alpha=> Map alpha beta-> alpha-> Maybe beta
lookup (Map s) a = lookup' s where
  lookup' []         = Nothing
  lookup' ((b, v):s) =
    if a == b then Just v else lookup' s

insert :: Eq alpha=> Map alpha beta-> alpha-> beta-> Map alpha beta
insert (Map s) a v = Map (insert' s) where
  insert' []         = [(a, v)]
  insert' ((b, w):s) = 
    if a == b then (a, v):s 
    else (b,w): insert' s  

lookup' (Map s) a = 
  case find ((a ==) . fst) s of
    Just (b, v) -> Just v
    Nothing     -> Nothing

lookup'' (Map s) a = fmap snd $ find ((a==) . fst) s

instance (Show alpha, Show beta)=> Show (Map alpha beta) where
  show (Map s) = show s

instance (Eq alpha, Eq beta)=> Eq (Map alpha beta) where
  Map s1 == Map s2 = 
    null (s1 \\ s2) && null (s1 \\ s2)

