module MapTest where

import Map3
import Prelude hiding (lookup)    
import Test.QuickCheck

-- Arbitrary-Instanz fr Map. 
-- Erzeugt eine Map zuflliger Lnge zwischen 0 und 20,
-- gefllt mit zuflligen Werten.
instance (Eq a, Arbitrary a, Arbitrary b)=> Arbitrary (Map a b) where
  arbitrary = do
   size <- choose (0, 20)
   a <- vector size
   b <- vector size
   return (foldl (\s (a, v)-> insert s a v) empty (zip a b))


-- Die Eigenschaften

-- Lesen der leeren Map
prop_read_empty :: Int-> Bool
prop_read_empty a = 
  lookup (empty :: Map Int Int) a == Nothing 
 
-- Lesen an derselben Stelle
prop_read_write :: Map Int Int-> Int-> Int-> Bool
prop_read_write s a v= 
  lookup (insert s a v) a == Just v

-- Lesen an anderer Stelle
prop_read_write_other :: 
  Map Int Int-> Int-> Int-> Int-> Property
prop_read_write_other s a v b= 
  a /= b ==> lookup (insert s a v) b == lookup s b

-- Schreiben an derselben Stelle
prop_write_write :: Map Int Int-> Int-> Int-> Int-> Bool
prop_write_write s a v w =
  insert (insert s a v) a w == insert s a w

-- Schreiben an anderer Stelle
prop_write_other :: 
  Map Int Int-> Int-> Int-> Int-> Int-> Property        
prop_write_other s a v b w =
  a /= b ==> insert (insert s a v) b w == 
             insert (insert s b w) a v
