module QueueTest where

import Queue
import Test.QuickCheck

-- Arbitrary-Instanz fr Stack. 
-- Erzeugt einen Stack zuflliger Lnge zwischen 0 und 20,
-- gefllt mit zuflligen Werten.
instance (Eq a, Arbitrary a)=> Arbitrary (Qu a) where
  arbitrary = do
   size <- choose (0, 20)
   a <- vector size
   return $ foldr enq empty a

prop_enq_mt :: Int-> Bool
prop_enq_mt a = first (enq a empty) == a

prop_enq_notmt :: Int-> Qu Int-> Property
prop_enq_notmt a q = 
  not (isEmpty q) ==> first (enq a q) == first q

prop_deq_mt :: Int-> Bool
prop_deq_mt a = deq (enq a empty) == empty

prop_deq_notmt :: Int-> Qu Int-> Property
prop_deq_notmt a q = 
  not (isEmpty q) ==> deq (enq a q) == enq a (deq q)

-- Der Rest ist trivial:
prop_mt :: Bool
prop_mt = isEmpty empty

prop_notmt_enq :: Int-> Qu Int-> Bool
prop_notmt_enq a q = not (isEmpty (enq a q))

prop_noneq_mt_enq :: Int-> Qu Int-> Bool
prop_noneq_mt_enq a q = enq a q /= empty
