module StackTest where

import Stack
import Test.QuickCheck

-- Arbitrary-Instanz fr Stack. 
-- Erzeugt einen Stack zuflliger Lnge zwischen 0 und 20,
-- gefllt mit zuflligen Werten.
instance (Eq a, Arbitrary a)=> Arbitrary (Stack a) where
  arbitrary = do
   size <- choose (0, 20)
   a <- vector size
   return $ foldr push empty a

prop_top_push :: Int-> Stack Int-> Bool
prop_top_push a s = top (push a s) == a

prop_pop_push :: Int-> Stack Int-> Bool
prop_pop_push a s = pop (push a s) == s

-- The other three properties are trivial:
prop_mt :: Bool
prop_mt = isEmpty empty

prop_push_not_mt :: Int-> Stack Int->Bool
prop_push_not_mt a s = not (isEmpty (push a s))

prop_mt_push :: Int-> Stack Int->Bool
prop_mt_push a s = empty /= push a s

